;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;										;;
;;			 Rectange Racer				;;
;;			 ==============				;;
;;										;;
;;			 By Forklift_Fred			;;
;;	 For SoCodor's Wednesday Workshop	;;
;;		#141 (05/03/08 - 12/03/08)		;;
;;										;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AppTitle "Rectangle Racer"

Graphics 640,480,32,2
SetBuffer BackBuffer()

Type rec
	Field x
	Field y
	Field width
	Field height
	Field depth
	Field count
	Field offset
End Type

Global printx
Global printy
Global centerx
Global centery
Global printheight

hiscore=0
.start
For rec.rec=Each rec
	Delete rec
Next

Cls
Color 255,255,255

InitMyPrint 320,30,1,1,17
MyPrint "Rectangle Racer"
MyPrint "==============="
MyPrint
MyPrint
MyPrint "Race throught the tunnel and get as far as you can."
MyPrint "If you leave the tunnel it will turn red and you will start to lose health"
MyPrint "Get back into the tunnel as quickly as possible so your health can restore"
MyPrint 
MyPrint "Run out of health and it's game over"
MyPrint 
MyPrint "Points are scored for progressing"
MyPrint "There's extra bonus points at 500 And 1000 distance intervals"
MyPrint "You must be inside the tunnel to gain the bonuses though!"
MyPrint 
MyPrint "Arrow keys to steer"
MyPrint "Watchout, the bends get tighter the further you go"
MyPrint "But your steering gets stronger..."
MyPrint 
MyPrint "PRESS ANY KEY TO START
MyPrint 
MyPrint 
MyPrint "Highscore: "+hiscore

Flip

FlushKeys
key=0
While Not KeyHit(1)
	key=GetKey()
	If key Then Exit
Wend
If Not key Then End

SeedRnd MilliSecs()
score=0


offset_x#=0
offset_y#=0
steering_x#=0
steering_y#=0
safe=True
crash#=0
change_x=0
adjust_x#=0
count=0

check=10
check1=0

steer#=1

HidePointer
While Not KeyHit(1)
	Cls
	steer=steer+0.0001
	check1=check1+1
	If check1=>check Then
		change_x=Rnd#(1,200)
		If change_x>100 Then adjust_x=1+(count/4000)
		If change_x<=100 Then adjust_x=1-(count/4000)
		check=Abs(change_x-100)
		check1=1
	End If
	;adjust_x=adjust_x*2
	offset_x=offset_x+(adjust_x/15)
	rec.rec=New rec
	rec\x=320+(offset_x*20);+(adjust_x*check1)
	rec\y=210
	rec\width=1
	rec\height=1
	rec\depth=10
	rec\count=count+1
	rec\offset=offset_x*20
	count=count+1
	
	If count Mod 20=1 Then
		rec\depth=rec\depth*4
		score=score+1
	End If
	
	If KeyDown(203) Then
		steering_x=steering_x-0.02*steer
		If steering_x<-0.2*steer Then steering_x=-0.2*steer
		;DebugLog "Left"
	Else If KeyDown(205) Then
		steering_x=steering_x+0.01*steer
		If steering_x>0.1*steer Then steering_x=0.1*steer
		;DebugLog "Right"
	Else
		If steering_x>0 Then steering_x=steering_x-0.01
		If steering_x<0 Then steering_x=steering_x+0.01
		If steering_x>-0.005 And steering_x<0.005 Then steering_x=0
	End If
	
	offset_x=offset_x-steering_x
	
	For rec.rec=Each rec
		Color rec\depth,rec\depth*safe,rec\depth*safe
		If rec\count Mod 1000=1 And safe Then
			Color rec\depth,rec\depth,255
			If rec\height>425 Then score=score+1000
		Else If rec\count Mod 500=1 And safe Then
			Color rec\depth,255,rec\depth
			If rec\height>425 Then score=score+500
		End If
		Rect rec\x,rec\y,rec\width,rec\height,0
		Rect rec\x+1,rec\y,rec\width,rec\height+1,0
		rec\x=rec\x-4+offset_x
		rec\y=rec\y-2
		rec\width=rec\width+8
		rec\height=rec\height+4
		rec\depth=rec\depth+2
		If rec\height>432 Then Delete rec
	Next
	rec.rec=First rec

	If rec\x-rec\offset=>320 Or rec\x+rec\width-rec\offset<=320 Then
		crash=crash+1
		safe=False
	Else
		crash=crash-0.25
		If crash<0 Then crash=0
		safe=True
	End If
	Color 255,0,0
	Text 5,432,"  Health: "+Int(400-crash)
	Text 5,447,"Distance: "+count
	Text 5,462,"   Score: "+score
	Text 200,462,"Hiscore: "+hiscore
	If crash=>400 Then
		Text 320,220,"Game Over!",1,1
		Text 320,220,"__________",1,1
		Text 320,240,"Your Score: "+score,1,1
		If score>hiscore Then
			hiscore=score
			Text 320,260,"NEW HISCORE!",1,1
		Else
			Text 320,260,"Hiscore: "+hiscore,1,1
		End If
		Flip
		
		FlushKeys
		key=0
		While Not KeyHit(1)
			key=GetKey()
			If key Then Exit
		Wend
		If Not key Then Exit
		Goto start
	End If
	Flip
Wend
Goto start
End
		

Function InitMyPrint(x,y,cx,cy,ph)
	printx=x
	printy=y
	centerx=cx
	centery=cy
	printheight=ph
End Function

Function MyPrint(txt$=" ")
	printy=printy+printheight
	Text printx,printy,txt$,centerx,centery
End Function
	
;~IDEal Editor Parameters:
;~C#Blitz3D